﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace z1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.BackColor = Color.White;
            this.KeyPreview = true;
            
            panel1.Paint += new PaintEventHandler(panel1Paint);
        }
        private void panel1Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Image img = Image.FromFile("E:\\Картинки\\index.jpg");


            ApplyTransformation(g);
            g.DrawImage(img, new Point(-img.Width / 2, -img.Height / 2));
            DrawAxis(g);
        }
        private void ApplyTransformation(Graphics g)
        {
            // Новая матрица преобразования
            Matrix m = new Matrix();
            // Определяем центр
            m.Translate(panel1.Width / 2, panel1.Height / 2);
            // Перемещение  
            if (rbTranslation.Checked)
            {
                
                int dx = Convert.ToInt16(tbTranslationX.Text);
                int dy = -Convert.ToInt16(tbTranslationY.Text);
                m.Translate(dx, dy);
            }
            // Маштабирование
            else if (rbScale.Checked)
            {
               
                float sx = Convert.ToSingle(tbScaleX.Text);
                float sy = Convert.ToSingle(tbScaleY.Text);
                m.Scale(sx, sy);
            }
            // Поворот 
            else if (rbRotation.Checked)
            {
                
                float angle = Convert.ToSingle(tbRotaionAngle.Text);
                float x = Convert.ToSingle(tbRotateAtX.Text);
                float y = -Convert.ToSingle(tbRotateAtY.Text);
                m.RotateAt(angle, new PointF(x, y));
            }
            // Сдвиг
            else if (rbShear.Checked)
            {
                
                float alpha = Convert.ToSingle(tbShearX.Text);
                float beta = Convert.ToSingle(tbShearY.Text);
                m.Shear(alpha, beta);
            }
            g.Transform = m;
          //  DrawFigure(g, Color.Black);
        }
        /*private void DrawFigure(Graphics g, Color color)
        {
            Pen p = new Pen(Color.Navy, 3);
            
            g.DrawRectangle(p, -46, -16, 92, 30);
           
            
                  }*/
        private void DrawAxis(Graphics g)
        {
            Matrix m = new Matrix();
            // определяем матрицу преобразований
            m.Translate(panel1.Width / 2, panel1.Height / 2);
            // Применяем матрицу преобразования к графическому объекту:
            g.Transform = m;
            // Рисуем оси x и y:
            g.DrawLine(Pens.Blue, -panel1.Width / 2, 0,panel1.Width / 2, 0);
            g.DrawLine(Pens.Blue, 0, -panel1.Height / 2,0, panel1.Height / 2);
            // Добавляем метки к осям X и Y:
            g.DrawString("X", this.Font, Brushes.Blue, panel1.Width / 2 - 20, -20);
            g.DrawString("Y", this.Font, Brushes.Blue, 5, -panel1.Height / 2 + 5);
            
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            panel1.Invalidate();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //Сбрасываем параметры к исходным
                tbTranslationX.Text = "0";
            tbTranslationY.Text = "0";
            tbScaleX.Text = "1";
            tbScaleY.Text = "1";
            tbRotaionAngle.Text = "0";
            tbRotateAtX.Text = "0";
            tbRotateAtY.Text = "0";
            tbShearX.Text = "0";
            tbShearY.Text = "0";
            panelbm.Invalidate();
        }

        private void button1_KeyDown(object sender, KeyEventArgs e)
        {
            {
                button1.PerformClick();// имитируем нажатие button1
            }
        }

        private void button2_KeyDown(object sender, KeyEventArgs e)
        {
            {
                button2.PerformClick();// имитируем нажатие button2
            }
        }

        
    }

}
